package jumpstart.max.business.commons.exception;

import javax.ejb.ApplicationException;

import jumpstart.max.util.UserFriendlyException;

@ApplicationException(rollback = true)
abstract public class ServiceException extends UserFriendlyException {

	public ServiceException(String messageId) {
		super(messageId);
	}
	
	public ServiceException(String messageId, Object[] messageArgs) {
		super(messageId, messageArgs);
	}
	
	public ServiceException(String messageId, Exception exception) {
		super(messageId, exception);
	}
	
	protected String getSimpleName(Class cls) {
		String s = cls.getName();
		String[] s1 = s.split("\\.");
		return s1[s1.length - 1];
	}
	
}
