package jumpstart.max.business.commons.exception;

import jumpstart.max.business.BaseTest;
import jumpstart.max.business.commons.exception.RemoveWhatException;
import jumpstart.max.business.commons.exception.ServiceException;
import jumpstart.max.business.commons.exception.UnexpectedException;
import jumpstart.max.business.domain.reference.CodeGroup;

public class TestRemoveWhatException extends BaseTest {

	public TestRemoveWhatException(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestRemoveWhatException.class);
	}

	public void test_RemoveWhatException_is_thrown_on_removing_null_part_from_whole() {
		
		// Don't expect a RemoveWhatException - instead, expect the service to fail with EJBException wrapping a NullPointerException

		try {
			_referenceManagerSvc.removeCode(null);
			fail("Should not reach here");
		}
		catch (Exception e) {
			ServiceException s = _interpreter.interpret(e);
			assertEquals(s.getMessage(), UnexpectedException.class, s.getClass());
			UnexpectedException u = (UnexpectedException) s;
			Throwable t = u.getException();
			assertEquals(t.getMessage(), NullPointerException.class, t.getClass());
		}

	}

	public void test_RemoveWhatException_is_thrown_on_removing_null_part_from_whole_while_detached() {

		try {
			CodeGroup cg = _referenceFinderSvc.findCodeGroup("cod_status");
			cg.removeCode(null);
			fail("Should not reach here");
		}
		catch (Exception e) {
			assertEquals(e.getMessage(), RemoveWhatException.class, e.getClass());
			assertEquals("Cannot remove Code from Code Group because Code not given.", e.getLocalizedMessage());
		}

	}

}
