package jumpstart.max.web.pages.starters;

import jumpstart.max.web.pages.login.LoginPage;

import org.apache.tapestry.IAsset;
import org.apache.tapestry.annotations.Asset;
import org.apache.tapestry.annotations.Bean;
import org.apache.tapestry.annotations.InjectState;
import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.valid.ValidationDelegate;

public abstract class DisablingValidatorsPage extends BasePage {
	static public final String PAGE_NAME = "pages/starters/DisablingValidatorsPage";

	@InjectState("myOrder")
	// myOrder is a session-scoped object - see hivemodule.xml.
	public abstract MyOrder getMyOrder();

	@Asset("context:/images/action-button.png")
	public abstract IAsset getButtonImage();
	
	@Bean
	// Beans get created and destroyed on the fly per request cycle
	public abstract ValidationDelegate getValidationDelegate();

	public abstract void setFirstName(String value);

	public void activate() {
		setFirstName("");
		getRequestCycle().activate(this);
	}

	public void doOrder(int orderQuantity) {
		sleep(2000); // Sleep 2 seconds to simulate busy system
		int newQuantity = getMyOrder().getQuantity() + orderQuantity;
		getMyOrder().setQuantity(newQuantity);
		DisablingValidatorsPage2 nextPage = (DisablingValidatorsPage2) getRequestCycle().getPage(
				DisablingValidatorsPage2.PAGE_NAME);
		nextPage.activate();
	}

	public void doRefresh() {
		setFirstName("");
	}

	public void doRefreshClearDelegate() {
		getValidationDelegate().clear();
		setFirstName("");
	}
	
	public void doToLogin() {
		LoginPage nextPage = (LoginPage) getRequestCycle().getPage(LoginPage.PAGE_NAME);
		nextPage.activate();
	}

	private void sleep(long duration) {
		try {
			Thread.sleep(duration);
		}
		catch (InterruptedException e) {
		}
	}
}