package jumpstart.max.web.pages.starters;

import jumpstart.max.web.pages.login.LoginPage;

import org.apache.tapestry.html.BasePage;

public abstract class ValidationPage extends BasePage {
	static public final String PAGE_NAME = "pages/starters/ValidationPage";

	public abstract String getFirstName();
	public abstract String getLastName();
	public abstract void setErrorMessage(String value);

	public void activate() {
		// No preparation required before activation.
		getRequestCycle().activate(this);
	}

	public void doDisplay() {
		String firstName = getFirstName();
		String lastName = getLastName();

		// Validate your name - error if it's empty
		
		if (firstName == null || firstName.equals("")) {
			setErrorMessage("First name is required.");
			return;
		}

		if (lastName == null || lastName.equals("")) {
			setErrorMessage("Last name is required.");
			return;
		}

		ValidationPage2 nextPage = (ValidationPage2) getRequestCycle().getPage(ValidationPage2.PAGE_NAME);
		nextPage.activate(firstName, lastName);
	}

	public void doToLogin() {
		LoginPage nextPage = (LoginPage) getRequestCycle().getPage(LoginPage.PAGE_NAME);
		nextPage.activate();
	}
}